#!/bin/sh
trap "" HUP

TASK_DIR=$1
TASK_SCRIPT_PATH=$2
TASK_TTL=600
if [ "`echo ${TASK_DIR} | grep '/$'`" = "" ]; then
	TASK_DIR="${TASK_DIR}/"
fi

if [ "`echo ${TASK_SCRIPT_PATH} | grep '/$'`" = "" ]; then
	TASK_SCRIPT_PATH="${TASK_SCRIPT_PATH}/"
fi

curtaskfname=""
curtask_birthtime=0
while true;
do
	sleep 3

	curtm=`date +%s`
	if [ "${curtaskfname}" != "" -a -e "${curtaskfname}" ]; then
		#当前任务正在执行，继续等待，不取新的任务.
		deadline=`expr ${curtask_birthtime} + ${TASK_TTL}`
		if [ ${deadline} -le ${curtm} ]; then
			#任务执行超时,删除任务文件
			rm -f ${curtaskfname}
			curtaskfname=""
		fi
		continue
	fi

	#当前任务执行完毕，取新的任务文件
	newtask=`ls ${TASK_DIR} | grep '.saastask' | head -n 1`
	[ "${newtask}" = "" ] && continue

	curtask_birthtime=${curtm}
	tasktype=`echo ${newtask} | cut -d '_' -f1`
	curtaskfname="${TASK_DIR}${newtask}"
	script=${TASK_SCRIPT_PATH}${tasktype}

	#args="`cat ${newtask}`"
	#echo "args:${args}"
	#由于saas_logclient APP升级或启用禁用等操作,会调用kill杀掉本脚本, 
	#这样会中断正在执行的任务，可能会导致出问题, 
	#故而让任务后台运行不受干扰.
	${script} "cur_taskfile=${curtaskfname}" > /dev/null 2>&1 &
done
