<?php
session_start();
set_time_limit(0);
$doc = $_SERVER["DOCUMENT_ROOT"];
include($doc."/common.php");
if (!chksession()) {
	outputres("no", "session expired");
	exit;
}

if (!isset($_REQUEST["action"])) {
	outputres("no", "no action");
	exit;
}
if (($action = postval("action")) == "") {
	outputres("no", "action null");
	exit;
}

function ap_set()
{
	$saasvr_domain = postval("saas_domain");
	$saasvr_port = postval("saas_port");
	$saassh_enable = postval("sshrc_enable");
	$passwd_free = postval("passwd_free");

	$sass_conf="/usr/logd/www/app/saas_logclient/saas_logclient.conf";
	$fp = fopen($sass_conf .".tmp", 'w');
	if($fp) {
		$cfgdata = "SAAS_PORT={$saasvr_port}\n"
		."SAAS_DOMAIN={$saasvr_domain}\n"
		."SSH_ENABLE={$saassh_enable}\n"
		."SSHRC_PASSWDFREE={$passwd_free}\n"
		."\n";
		fwrite($fp, $cfgdata);
		fclose($fp);
	}
	rename($sass_conf .".tmp", $sass_conf);

	$cmd = "/usr/logd/www/app/saas_logclient/appctrl status";
	exec($cmd, $out, $ret);
	if ($ret == 0) {
		if ($out[0] == 'enable') {
			$cmd = "/usr/logd/www/app/saas_logclient/appctrl start";
			exec($cmd);
		}
	}
	
	// $cmd = "echo 'saasclient set' >> /var/log/saas_logclient.log";
	// exec($cmd);

	if (empty($saasvr_domain) && empty($saasvr_port)) {
		// outputres("no", "domain and port empty!");
		echo json_encode(['code'=>1, 'msg'=>'domain and port empty!']);
		exit;
	}
	
	echo json_encode(['code'=>0, 'msg'=>'设置成功']);
}

function ap_stat()
{
	$sshrc_enable = false;
	$saasvr_domain = '';
	$saasvr_port = 0;
	$logsn = '';
	$islink = false;
	$keyno = '';
	$passwd_free=false;

	$sass_conf="/usr/logd/www/app/saas_logclient/saas_logclient.conf";
	if(file_exists($sass_conf)) {
		$fp = fopen($sass_conf, 'r');
		if($fp) {
			while(!feof($fp)) {
				if(($buf = fgets($fp)) === false)
					break;
				if(empty($buf = trim($buf)))
					continue;
				if(strpos($buf, 'SAAS_DOMAIN=') === 0) {
					$saasvr_domain = strval(substr($buf, strlen('SAAS_DOMAIN=')));
				}
				else if(strpos($buf, 'SAAS_PORT=') === 0) {
					$saasvr_port = intval(substr($buf, strlen('SAAS_PORT=')));
				}
				else if(strpos($buf, 'SSH_ENABLE=') === 0) {
					$is_enable = intval(substr($buf, strlen('SSH_ENABLE=')));
					if ($is_enable == 1) {
						$sshrc_enable = true;
					}
					else {
						$sshrc_enable = false;
					}
				}
				else if(strpos($buf, 'SSHRC_PASSWDFREE=') === 0) {
					$is_enable = intval(substr($buf, strlen('SSHRC_PASSWDFREE=')));
					if ($is_enable == 1) {
						$passwd_free = true;
					}
					else {
						$passwd_free = false;
					}
				}
			}
			fclose($fp);
		}
	}

	// $cmd = "echo 'saasclient stat {$saasvr_domain} {$saasvr_port} {$sshrc_enable}' >> /var/log/saas_logclient_web.log";
	// exec($cmd);

	$cmd = "panalogeye key get";
	unset($out);unset($ret);
	exec($cmd, $out, $ret);
	if ($ret == 0) {
		$logsn = $out[0];
	}

	$cmd = "panalogeye key stat|grep 'keyno='";
	unset($out);unset($ret);
	exec($cmd, $out, $ret);
	if ($ret == 0) {
		$output = explode("=", $out[0]);
		$keyno = $output[1];
	}
	if (empty($keyno)) {
		$cmd = "panalogeye key get ver=free";
		unset($out);unset($ret);
		exec($cmd, $out, $ret);
		if ($ret == 0) {
			$output = explode(" ", $out[0]);
			$keyno =$output[1];
		}
	}

	// SAAS_SERVER_ONLINETAG_FILE="${LOGROOT}/app/${APP_NAME}/saas_server_online_tag"
	$apptagfile = "/usr/logd/www/app/saas_logclient/saas_server_online_tag";
	if (file_exists($apptagfile)) {
		$apprtime_str = file_get_contents($apptagfile);
		$apprtime = intval(trim($apprtime_str));
		$curtime = time();
		if ($curtime - $apprtime < 60) {
			$islink = true;
		}
	}

	$json = array(
		"saaserver_state"=>$islink,
		"logsn"=>$logsn,
		"keyno"=>$keyno,
		"sshrc_enable"=>$sshrc_enable, 
		"passwd_free"=>$passwd_free,
		"saas_domain"=>$saasvr_domain,
		"saas_port"=>$saasvr_port
		);
	echo json_encode($json);
}

switch($action)
{
case "ap_set":
	ap_set();
	break;

case "ap_stat":
	ap_stat();
	break;

default:
	outputres("no", "INVALID_ACTION");
	// $cmd = "echo 'saasclient unknown action' >> /var/log/saas_logclient_web.log";
	// exec($cmd);
	exit;
}

?>

















